Index: test/edu/ucsb/nceas/metacattest/AccessAPITest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/AccessAPITest.java	(revision 6743)
+++ test/edu/ucsb/nceas/metacattest/AccessAPITest.java	(revision 6744)
@@ -137,7 +137,7 @@
 					true);
 			accessDAOList = new Vector<XMLAccessDAO>();
 			accessDAO = new XMLAccessDAO();
-			accessDAO.setDocId(docId);
+			accessDAO.setGuid(docId);
 			accessDAO.setPrincipalName(principal);
 			accessDAO.setPermission(new Long(AccessControlInterface.READ));
 			accessDAO.setPermType(AccessControlInterface.ALLOW);
@@ -470,7 +470,7 @@
                 
                 System.out.println("subAccessDAO.perm: '" + subAccessDAO.getPermission() + "'");
                 System.out.println("mainAccessDAO.perm: '" + mainAccessDAO.getPermission() + "'");*/
-				if (subAccessDAO.getDocId().equals(mainAccessDAO.getDocId()) &&
+				if (subAccessDAO.getGuid().equals(mainAccessDAO.getGuid()) &&
 						subAccessDAO.getPermOrder().equals(mainAccessDAO.getPermOrder()) &&
 						subAccessDAO.getPermType().equals(mainAccessDAO.getPermType()) &&
 						subAccessDAO.getPrincipalName().equals(mainAccessDAO.getPrincipalName()) &&
@@ -540,7 +540,7 @@
 	 */
 	private void debugAccessDAOList(Vector<XMLAccessDAO> accessDAOList) {
 		for (XMLAccessDAO xmlAccessDAO : accessDAOList) {
-			debug("Doc ID:      " + xmlAccessDAO.getDocId());
+			debug("Guid:      " + xmlAccessDAO.getGuid());
 			debug("Perm Order:  " + xmlAccessDAO.getPermOrder());
 			debug("Perm Type:   " + xmlAccessDAO.getPermType());
 			debug("Principal    " + xmlAccessDAO.getPrincipalName());
Index: src/upgrade-db-to-2.0.0-postgres.sql
===================================================================
--- src/upgrade-db-to-2.0.0-postgres.sql	(revision 6743)
+++ src/upgrade-db-to-2.0.0-postgres.sql	(revision 6744)
@@ -61,10 +61,6 @@
  * Replication changes to support DataONE System Metadata replication
  */
 ALTER TABLE xml_replication ADD COLUMN systemmetadatareplicate INT8;
-/*
- *  Allow guid in xml_access table (for system metadata)
-*/
-ALTER TABLE xml_access ADD COLUMN guid text;
 
 /**
  * track the user-agent for the request
@@ -76,6 +72,66 @@
  */
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', '@eml2_1_1namespace@', '/schema/eml-2.1.1/eml.xsd');  
+
+/**
+ * Generate GUIDs for docid.rev
+ */
+INSERT INTO identifier (docid, rev, guid) 
+	SELECT docid, rev, docid || '.' || rev FROM xml_documents;
+INSERT INTO identifier (docid, rev, guid)
+	SELECT docid, revisionid, docid || '.' || revisionid FROM xml_revisions;
+
+/**
+ *  Allow guid in xml_access table (for system metadata)
+ */
+ALTER TABLE xml_access ADD COLUMN guid text;
+
+/**
+ * Upgrade xml_access records to use GUID from identifier table
+ */
+INSERT INTO xml_access (
+	guid, principal_name, permission, perm_type, perm_order, 
+	docid, accessfileid, begin_time, end_time, ticket_count, subtreeid, startnodeid, endnodeid
+)
+	SELECT 
+		id.guid, xa.principal_name, xa.permission, xa.perm_type, xa.perm_order, 
+		xa.docid, xa.accessfileid, xa.begin_time, xa.end_time, xa.ticket_count, xa.subtreeid, xa.startnodeid, xa.endnodeid
+	FROM identifier id, xml_access xa
+	WHERE id.docid = xa.docid;
+
+/**
+ * Include inline access rows -- they have a special guid: 'scope.docid.rev.index'
+ */
+INSERT INTO xml_access (
+	guid, principal_name, permission, perm_type, perm_order, 
+	docid, accessfileid, begin_time, end_time, ticket_count, subtreeid, startnodeid, endnodeid
+)
+	SELECT 
+		docid, principal_name, permission, perm_type, perm_order, 
+		docid, accessfileid, begin_time, end_time, ticket_count, subtreeid, startnodeid, endnodeid
+	FROM xml_access
+	WHERE docid like '%.%.%.%';
+
+/**
+ * Update the accessfileid to use guid
+ * TODO: specific revision should be used
+ */
+UPDATE xml_access
+SET accessfileid = id.guid
+FROM identifier id, xml_access xa
+WHERE xa.accessfileid = id.docid
+
+
+/**
+ * Remove old access rules
+ */
+DELETE FROM xml_access WHERE guid is null;
+
+/**
+ * clean up the xml_access table
+ */
+ALTER TABLE xml_access DROP COLUMN docid;
+
 /*
  * update the database version
  */
Index: src/xmltables-postgres.sql
===================================================================
--- src/xmltables-postgres.sql	(revision 6743)
+++ src/xmltables-postgres.sql	(revision 6744)
@@ -209,7 +209,6 @@
  * ACL -- table to store ACL for XML documents by principals
  */
 CREATE TABLE xml_access (
-	docid VARCHAR(250),	-- the document id #
 	guid text,	-- foreign key to system metadata
 	accessfileid VARCHAR(250),	-- the document id # for the access file
 	principal_name VARCHAR(100),	-- name of user, group, etc.
Index: src/edu/ucsb/nceas/metacat/QuerySpecification.java
===================================================================
--- src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 6744)
@@ -272,7 +272,7 @@
     {
         String allowQuery = null;
         String allowString = constructAllowString();
-        allowQuery = "SELECT docid from xml_access WHERE( " + allowString;
+        allowQuery = "SELECT id.docid from xml_access xa, identifier id WHERE id.guid = xa.guid AND ( " + allowString;
         allowQuery = allowQuery + ")";
         logMetacat.info("QuerySpecification.createAllowRuleQuery - allow query is: " + allowQuery);
         return allowQuery;
@@ -319,7 +319,7 @@
     {
         String denyQuery = null;
         String denyString = constructDenyString();
-        denyQuery = "SELECT docid from xml_access WHERE( " + denyString;
+        denyQuery = "SELECT id.docid from xml_access xa, identifier id WHERE id.guid = xa.guid AND ( " + denyString;
         denyQuery = denyQuery + ") ";
         logMetacat.info("QuerySpecification.createDenyRuleQuery - denyquery is: " + denyQuery);
         return denyQuery;
Index: src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java
===================================================================
--- src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java	(revision 6744)
@@ -71,7 +71,7 @@
   }
 
   /**
-   * Returns a Vector of all the docids in the xml_path_index tables
+   * Returns a Vector of all the current versions of public docids
    */
   protected Vector<String> queryAllDocids() {
     Vector<String> _docs = new Vector<String>();
@@ -83,7 +83,13 @@
      * to be considered for the spatial cache
      */
     //String query = "select distinct docid from xml_path_index";
-    String query = "select distinct docid from xml_access where principal_name = 'public' and perm_type = 'allow'";
+    String query = "select distinct id.docid " +
+    		"from xml_access xa, identifier id, xml_documents xd " +
+    		"where xa.guid = id.guid " +
+    		"and id.docid = xd.docid " +
+    		"and id.rev = xd.rev " +
+    		"and xa.principal_name = 'public' " +
+    		"and xa.perm_type = 'allow'";
 
     try {
       pstmt = dbconn.prepareStatement(query);
Index: src/edu/ucsb/nceas/metacat/spatial/SpatialDocument.java
===================================================================
--- src/edu/ucsb/nceas/metacat/spatial/SpatialDocument.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/spatial/SpatialDocument.java	(revision 6744)
@@ -143,12 +143,18 @@
 		if (isSpatialDocument) {
 
 			/*
-			 * Get the bounding coordinates
+			 * Get the bounding coordinates for current public revision
 			 */
 			query = "SELECT path, nodedatanumerical, parentnodeid FROM xml_path_index"
 					+ " WHERE docid = ?"
-					+ " AND docid IN (SELECT distinct docid FROM xml_access WHERE docid = ?"
-					+ " AND principal_name = 'public' AND perm_type = 'allow')"
+					+ " AND docid IN " +
+							"(SELECT distinct id.docid " +
+							"FROM identifier id, xml_access xa, xml_documents xd "
+							+ " WHERE id.docid = ?"
+							+ " AND id.docid = xd.docid "
+							+ " AND id.rev = xd.rev "
+							+ " AND id.guid = xa.guid "
+							+ " AND xa.principal_name = 'public' AND xa.perm_type = 'allow')"
 					+ " AND (path = '" + westPath + "'" + "  OR path = '" + southPath
 					+ "'" + "  OR path = '" + eastPath + "'" + "  OR path = '"
 					+ northPath + "'" + " ) ORDER BY parentnodeid;";
Index: src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 6744)
@@ -177,7 +177,7 @@
     ResultSet rs=null;
     
     //the query stirng
-    String query="SELECT docid from xml_access";
+    String query="SELECT id.docid from xml_access xa, identifier id where xa.guid = id.guid";
     try
     {
       pStmt=conn.prepareStatement(query);
@@ -409,8 +409,8 @@
             docId=(String)docList.nextElement();
             dataSetId=(String)docIdMapDataSetId.get(docId);
             query="select accessfileid, principal_name,permission,perm_type,"
-                +"perm_order,begin_time,end_time,ticket_count from xml_access "
-                +"where docid =?";
+                +"perm_order,begin_time,end_time,ticket_count from xml_access xa, identifier id "
+                +"where id.docid = ? and id.guid = xa.guid";
             pStmt=conn.prepareStatement(query);
             //bind the value to query
             pStmt.setString(1, dataSetId);
